import UIKit
import Mapbox

class ViewController: UIViewController /*, MGLMapViewDelegate*/ {

    var map: MGLMapView!

    override func viewDidLoad() {
        super.viewDidLoad()

        // ======================================================================

        // Basic setup
        //
        // Add MGLMapboxAccessToken to Info.plist
        map = MGLMapView(frame: view.bounds)
        map.autoresizingMask = [.flexibleWidth, .flexibleHeight]
        view.addSubview(map)

        // ======================================================================

        // User location
        //
        // Add NSLocationWhenInUseUsageDescription to Info.plist
        // map.showsUserLocation = true
        // map.userTrackingMode = .follow

        // ======================================================================

        // Bundled styles
        //
        // map.styleURL = MGLStyle.darkStyleURL(withVersion: 9)
        // map.styleURL = MGLStyle.lightStyleURL(withVersion: 9)
        // map.styleURL = MGLStyle.satelliteStreetsStyleURL(withVersion: 9)

        // ======================================================================

        // Setting delegate
        // map.delegate = self

        // ======================================================================

        // Annotations
        //
        // let point = MGLPointAnnotation()
        // point.coordinate = CLLocationCoordinate2D(latitude: 37.328611, longitude: -121.888889)
        // map.addAnnotation(point)
        // map.showAnnotations([point], animated: false)
        // map.zoomLevel = 15 // 0: world, 5: continents, 10: regions, 15: cities, 20: buildings

        // ======================================================================

        // Camera movement
        //
        // DispatchQueue.main.asyncAfter(deadline: .now() + .seconds(5)) { [unowned self] in
        //     self.firstMoveCamera()
        // }
    }

    // ======================================================================

    // Custom annotation image
    //
    // func mapView(_ mapView: MGLMapView, imageFor annotation: MGLAnnotation) -> MGLAnnotationImage? {
    //     if annotation is MGLUserLocation {
    //         return nil
    //     }
    //     var image: MGLAnnotationImage?
    //     if let existingImage = mapView.dequeueReusableAnnotationImage(withIdentifier: "apple") {
    //         image = existingImage
    //     } else {
    //         image = MGLAnnotationImage(image: UIImage(named: "apple.png")!, reuseIdentifier: "apple")
    //     }
    //     return image
    // }

    // ======================================================================

    // Custom annotation view
    //
    // func mapView(_ mapView: MGLMapView, viewFor annotation: MGLAnnotation) -> MGLAnnotationView? {
    //     if annotation is MGLUserLocation {
    //         return nil
    //     }
    //     var view: MGLAnnotationView?
    //     if let existingView = mapView.dequeueReusableAnnotationView(withIdentifier: "apple") {
    //         view = existingView
    //     } else {
    //         view = MGLAnnotationView(frame: CGRect(x: 0, y: 0, width: 50, height: 50))
    //         view?.backgroundColor = .red
    //         view?.alpha = 0.75
    //         view?.layer.cornerRadius = 10
    //         view?.layer.borderColor = UIColor.white.cgColor
    //         view?.layer.borderWidth = 2
    //     }
    //     return view
    // }

    // ======================================================================

    // Camera movement
    //
    // func firstMoveCamera() {
    //     let camera = MGLMapCamera(lookingAtCenter: map.centerCoordinate,
    //                               fromDistance: 500,
    //                               pitch: 60,
    //                               heading: 0)
    //     map.setCamera(camera,
    //                   withDuration: 2,
    //                   animationTimingFunction: CAMediaTimingFunction(name: kCAMediaTimingFunctionEaseInEaseOut))
    //     DispatchQueue.main.asyncAfter(deadline: .now() + .seconds(5)) { [unowned self] in
    //         self.secondMoveCamera()
    //     }
    //
    // }

    // func secondMoveCamera() {
    //     let camera = MGLMapCamera(lookingAtCenter: map.centerCoordinate,
    //                               fromDistance: 5000,
    //                               pitch: 60,
    //                               heading: 180)
    //     map.setCamera(camera,
    //                   withDuration: 2,
    //                   animationTimingFunction: CAMediaTimingFunction(name: kCAMediaTimingFunctionEaseInEaseOut))
    // }

    // ======================================================================

    // Runtime styling
    //
    // func mapView(_ mapView: MGLMapView, didFinishLoading style: MGLStyle) {
    //      print((style.layers as NSObject).value(forKeyPath: "identifier"))
    //
    //     if let parks = style.layer(withIdentifier: "park") as? MGLFillStyleLayer {
    //         parks.fillColor = MGLStyleValue(rawValue: UIColor(red: 0.899, green: 0.695, blue: 0.282, alpha: 1))
    //     }
    //
    //     for layer in style.layers {
    //         if layer.identifier.contains("-") {
    //             layer.isVisible = false
    //         } else if let layer = layer as? MGLFillStyleLayer {
    //             layer.fillOpacity = MGLStyleValue(rawValue: 0.5)
    //         } else if let layer = layer as? MGLLineStyleLayer {
    //             layer.lineOpacity = MGLStyleValue(rawValue: 0.5)
    //         }
    //     }
    // }

}
